// PicViewer3.cpp : Defines the entry point for the application.
//

#include "stdafx.h"
#include "resource.h"
#include "PicViewer3.h"

#include "PicReaderC.h"

#define MAX_LOADSTRING 100

// Global Variables:
HINSTANCE hInst;								// current instance
TCHAR szTitle[MAX_LOADSTRING];								// The title bar text
TCHAR szWindowClass[MAX_LOADSTRING];								// The title bar text

//===============================================
// Quick & Dirty global variables
//===============================================
HBITMAP Bitmap;
HDC MemoryDC;
bool BitmapAvailable=false;
long BitsPixel;

HBRUSH BackBrush;

bool PaletteVisible=false;
bool Magnify2x=false;
bool Frame=false;

long Width;
long Height;

CPicReaderC PicImage;
char Filename[MAX_PATH];
//===============================================
void CreateBitmap();
//===============================================


// Foward declarations of functions included in this code module:
ATOM				MyRegisterClass(HINSTANCE hInstance);
BOOL				InitInstance(HINSTANCE, int);
LRESULT CALLBACK	WndProc(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK	About(HWND, UINT, WPARAM, LPARAM);

int APIENTRY WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR     lpCmdLine,
                     int       nCmdShow)
{
 	// TODO: Place code here.
	MSG msg;
	HACCEL hAccelTable;

	// Initialize global strings
	LoadString(hInstance, IDS_APP_TITLE, szTitle, MAX_LOADSTRING);
	LoadString(hInstance, IDC_PICVIEWER3, szWindowClass, MAX_LOADSTRING);
	MyRegisterClass(hInstance);

	// Perform application initialization:
	if (!InitInstance (hInstance, nCmdShow)) 
	{
		return FALSE;
	}

	hAccelTable = LoadAccelerators(hInstance, (LPCTSTR)IDC_PICVIEWER3);

	OutputDebugString(lpCmdLine);
	Filename[0]=0;
	if (lpCmdLine[0]!=0)
	{
		if (lpCmdLine[0]=='"')
		{
			lpCmdLine++;
		}
		if (lpCmdLine[strlen(lpCmdLine)-1]=='"')
		{
			lpCmdLine[strlen(lpCmdLine)-1]=0;
		}

		strcpy(Filename,lpCmdLine);
	}

	// Main message loop:
	while (GetMessage(&msg, NULL, 0, 0)) 
	{
		if (!TranslateAccelerator(msg.hwnd, hAccelTable, &msg)) 
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}

	return msg.wParam;
}



//
//  FUNCTION: MyRegisterClass()
//
//  PURPOSE: Registers the window class.
//
//  COMMENTS:
//
//    This function and its usage is only necessary if you want this code
//    to be compatible with Win32 systems prior to the 'RegisterClassEx'
//    function that was added to Windows 95. It is important to call this function
//    so that the application will get 'well formed' small icons associated
//    with it.
//
ATOM MyRegisterClass(HINSTANCE hInstance)
{
	WNDCLASSEX wcex;

	wcex.cbSize = sizeof(WNDCLASSEX); 

	wcex.style			= CS_HREDRAW | CS_VREDRAW;
	wcex.lpfnWndProc	= (WNDPROC)WndProc;
	wcex.cbClsExtra		= 0;
	wcex.cbWndExtra		= 0;
	wcex.hInstance		= hInstance;
	wcex.hIcon			= LoadIcon(hInstance, (LPCTSTR)IDI_PICVIEWER3);
	wcex.hCursor		= LoadCursor(NULL, IDC_ARROW);
	wcex.hbrBackground	= (HBRUSH)(COLOR_WINDOW+1);
	wcex.lpszMenuName	= (LPCSTR)IDC_PICVIEWER3;
	wcex.lpszClassName	= szWindowClass;
	wcex.hIconSm		= LoadIcon(wcex.hInstance, (LPCTSTR)IDI_SMALL);

	return RegisterClassEx(&wcex);
}

//
//   FUNCTION: InitInstance(HANDLE, int)
//
//   PURPOSE: Saves instance handle and creates main window
//
//   COMMENTS:
//
//        In this function, we save the instance handle in a global variable and
//        create and display the main program window.
//
BOOL InitInstance(HINSTANCE hInstance, int nCmdShow)
{
   HWND hWnd;

   hInst = hInstance; // Store instance handle in our global variable

   hWnd = CreateWindow(szWindowClass, szTitle, WS_OVERLAPPEDWINDOW,
      CW_USEDEFAULT, 0, CW_USEDEFAULT, 0, NULL, NULL, hInstance, NULL);

   if (!hWnd)
   {
      return FALSE;
   }

   ShowWindow(hWnd, nCmdShow);
   UpdateWindow(hWnd);

   Setup(hWnd);

   return TRUE;
}

//
//  FUNCTION: WndProc(HWND, unsigned, WORD, LONG)
//
//  PURPOSE:  Processes messages for the main window.
//
//  WM_COMMAND	- process the application menu
//  WM_PAINT	- Paint the main window
//  WM_DESTROY	- post a quit message and return
//
//
LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	int wmId, wmEvent;

	switch (message) 
	{
		case WM_COMMAND:
		{
			wmId    = LOWORD(wParam); 
			wmEvent = HIWORD(wParam); 
			// Parse the menu selections:
			switch (wmId)
			{
				case IDM_ABOUT:
				   DialogBox(hInst, (LPCTSTR)IDD_ABOUTBOX, hWnd, (DLGPROC)About);
				break;
				case IDM_EXIT:
				   DestroyWindow(hWnd);
				break;
				   
				case ID_FILE_OPEN: // File|Open
				{
					Open(hWnd);
				}
				break;
				case ID_VIEW_PALETTE: // View|Palette
				{
					PaletteVisible=!PaletteVisible;
					InvalidateRect(hWnd,NULL,true);
				}
				break;
				case ID_VIEW_MAGNIFY2X: // View|Magnify
				{
					Magnify2x=!Magnify2x;
					InvalidateRect(hWnd,NULL,true);
				}
				break;
				case ID_VIEW_FRAME: // View|Frame
				{
					Frame=!Frame;
					InvalidateRect(hWnd,NULL,true);
				}
				break;

				default:
				   return DefWindowProc(hWnd, message, wParam, lParam);
			}
		}
		break;
		case WM_CREATE:
		{
			// OnInitialUpdate
			PostMessage(hWnd,WM_USER+2,0,0);
		}
		break;
		case WM_PAINT:
		{
			Paint(hWnd);
		}
		break;
		case WM_ERASEBKGND:
		{
			// Do nothing
		}
		break;
		case WM_USER+2: // OnInitialUpdate
		{
			Setup(hWnd);
		}
		break;		
		case WM_DESTROY:
			PostQuitMessage(0);
			break;
		default:
		{
			//TRACE("Message: %x %x %x\n",message,wParam,lParam);
			return DefWindowProc(hWnd, message, wParam, lParam);
		}
		break;
   }
   return 0;
}

// Mesage handler for about box.
LRESULT CALLBACK About(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch (message)
	{
		case WM_INITDIALOG:
				return TRUE;

		case WM_COMMAND:
			if (LOWORD(wParam) == IDOK || LOWORD(wParam) == IDCANCEL) 
			{
				EndDialog(hDlg, LOWORD(wParam));
				return TRUE;
			}
			break;
	}
    return FALSE;
}


void Setup(HWND hWnd)
{
	// Setup initial variables
	Width=0;
	Height=0;

	// Setup Memory DC
	HDC ScreenDC;
	ScreenDC=GetDC(GetDesktopWindow());
	BitsPixel=GetDeviceCaps(ScreenDC,BITSPIXEL);
	MemoryDC=CreateCompatibleDC(ScreenDC);
	ReleaseDC(GetDesktopWindow(),ScreenDC);

	BackBrush=(HBRUSH)GetStockObject(BLACK_BRUSH);

	if (Filename[0]!=0)
	{
		PicImage.Load(Filename);

		if (PicImage.IsValid())
		{
			CreateBitmap();

			SetWindowText(hWnd,Filename);
		}
	}

	InvalidateRect(hWnd,NULL,true);
}

void CreateBitmap()
{
	if (PicImage.IsValid())
	{
		Width=PicImage.GetWidth();
		Height=PicImage.GetHeight();

		Bitmap=CreateBitmap(Width,Height,1,BitsPixel,NULL);
		SelectObject(MemoryDC,Bitmap);
		BitmapAvailable=true;

		long Y,X;

		for (Y=0;Y<Height;Y++)
		{
			for (X=0;X<Width;X++)
			{
				SetPixel(MemoryDC,X,Y,PicImage.GetPixel(X,Y));
			}
		}
	}
}

void Open(HWND hWnd)
{
	char FileTitle[MAX_PATH];

	OPENFILENAME OFNData;

	ZeroMemory(&OFNData,sizeof(OPENFILENAME));
	OFNData.lStructSize=sizeof(OPENFILENAME);
	OFNData.hwndOwner=hWnd;
	OFNData.lpstrFilter=".pic";
	OFNData.lpstrFileTitle=FileTitle;
	OFNData.nMaxFileTitle=MAX_PATH;
	OFNData.Flags=OFN_FILEMUSTEXIST|OFN_HIDEREADONLY;

	if (GetOpenFileName(&OFNData))
	{
		DeleteObject(Bitmap);
		Width=0;
		Height=0;
		BitmapAvailable=false;

		PicImage.Load(OFNData.lpstrFileTitle);

		if (PicImage.IsValid())
		{
			CreateBitmap();

			SetWindowText(hWnd,OFNData.lpstrFileTitle);
		}
	}

	InvalidateRect(hWnd,NULL,true);
}

void Paint(HWND hWnd)
{
	PAINTSTRUCT ps;
	HDC hdc;
	TCHAR szHello[MAX_LOADSTRING];
	LoadString(hInst, IDS_HELLO, szHello, MAX_LOADSTRING);

	hdc = BeginPaint(hWnd, &ps);

	RECT FrameRect;
	RECT Rect;
	GetClientRect(hWnd, &Rect);
	FillRect(hdc,&Rect,BackBrush);

	long X,Y;
	long DrawWidth,DrawHeight;

	if (PaletteVisible)
	{
		Rect.bottom-=30;
	}

	X=0;
	Y=0;
	DrawWidth=Width;
	DrawHeight=Height;

	if (Magnify2x)
	{
		DrawWidth*=2;
		DrawHeight*=2;
	}

	// Center
	X=(Rect.right-DrawWidth)/2;
	Y=(Rect.bottom-DrawHeight)/2;

	X=max(X,0);
	Y=max(Y,0);

	if (BitmapAvailable)
	{
		if (Frame)
		{
			FrameRect.left=X-2;
			FrameRect.top=Y-2;
			FrameRect.right=X+DrawWidth+2;
			FrameRect.bottom=Y+DrawHeight+2;

			DrawEdge(hdc,&FrameRect,EDGE_RAISED,BF_RECT);
		}

		if (!Magnify2x)
		{
			BitBlt(hdc,X,Y,Width,Height,MemoryDC,0,0,SRCCOPY);
		}
		else
		{
			StretchBlt(hdc,X,Y,DrawWidth,DrawHeight,MemoryDC,0,0,Width,Height,SRCCOPY);
		}
	}	

	// Draw Palette
	if (PaletteVisible)
	{
		COLORREF CurColor;
		long cnt;

		long XDelta;
		long OrixX;

		long Square=5;

		RECT PaletteRect;
		HBRUSH PaletteBrush;

		X=0;
		Y=Rect.bottom+3;
		XDelta=(Square+1)*64+2;
		OrixX=max(3,(Rect.right-(64*(Square+1)+1)*2)/2);

		// Draw palettes on white background
		PaletteBrush=(HBRUSH)GetStockObject(WHITE_BRUSH);

		PaletteRect.left=0;
		PaletteRect.top=Rect.bottom;
		PaletteRect.right=Rect.right;
		PaletteRect.bottom=Rect.bottom+30;

		FillRect(hdc,&PaletteRect,PaletteBrush);

		// Draw Palettes with black Frame
		PaletteBrush=(HBRUSH)GetStockObject(BLACK_BRUSH);

		PaletteRect.left=OrixX+X-1,Y-1;
		PaletteRect.top=Y-1;
		PaletteRect.right=PaletteRect.left+64*(Square+1)+1;
		PaletteRect.bottom=PaletteRect.top+(Square+1)*4+1;

		FillRect(hdc,&PaletteRect,PaletteBrush);

		PaletteRect.left=OrixX+X-1+XDelta,Y-1; 
		PaletteRect.top=Y-1;
		PaletteRect.right=PaletteRect.left+64*(Square+1)+1;
		PaletteRect.bottom=PaletteRect.top+(Square+1)*4+1;

		FillRect(hdc,&PaletteRect,PaletteBrush);

		// Setup for first inc
		Y-=Square+1;

		for (cnt=0;cnt<256;cnt++)
		{
			if (cnt%64==0)
			{
				X=0;
				Y+=Square+1;
			}

			CurColor=PicImage.GetColor(cnt);

			PaletteBrush=CreateSolidBrush(CurColor);

			PaletteRect.left=OrixX+X;
			PaletteRect.top=Y;
			PaletteRect.right=OrixX+X+Square;
			PaletteRect.bottom=Y+Square;

			FillRect(hdc,&PaletteRect,PaletteBrush);

			PaletteRect.left+=XDelta;
			PaletteRect.right+=XDelta+1;

			FillRect(hdc,&PaletteRect,PaletteBrush);

			X+=Square+1;

			DeleteObject(PaletteBrush);
		}
	}

	EndPaint(hWnd, &ps);
}
